"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const time_interval_1 = __importDefault(require("./intervals/time_interval"));
// require('babel-register')
const Koa = require('koa');
const app = new Koa();
const views = require('koa-views');
const json = require('koa-json');
const onerror2 = require('koa-onerror');
const bodyparser = require('koa-bodyparser');
// const logger = require('koa-logger')
const cors = require("@koa/cors");
const index = require('./routes/index');
const impalaTask = require('./routes/impala_task');
const impalaStatistic = require('./routes/impala_statistic');
// cors
app.use(cors());
// error handler
onerror2(app);
// middlewares
app.use(bodyparser({
    enableTypes: ['json', 'form', 'text']
}));
app.use(json());
// app.use(logger())
app.use(require('koa-static')(__dirname + '/public'));
app.use(views(__dirname + '/views', {
    extension: 'pug'
}));
//#region 日志模块
const logging = require("@kasa/koa-logging");
const pino = require("pino");
// 日志格式化服务 序列化操作
const serializers = require("@kasa/koa-logging/lib/serializers");
const requestId = require("@kasa/koa-request-id");
function resBodySerializer(param) {
    const { status, code, message } = param;
    const body = {
        status,
        message,
        code,
    };
    if (!code) {
        delete body.code;
    }
    return body;
}
function resSerializer(ctx) {
    return {
        statusCode: ctx.status,
        duration: ctx.duration,
        type: ctx.type,
        headers: (ctx.response || {}).headers,
        body: resBodySerializer(ctx.body || {}),
    };
}
app.use(requestId());
app.use(logging({
    logger: pino({
        enabled: true,
        level: "info",
        serializers: Object.assign(Object.assign({}, serializers), { res: resSerializer }),
    }),
}));
//#endregion
// routes
app.use(index.routes(), index.allowedMethods());
app.use(impalaTask.routes(), impalaTask.allowedMethods());
app.use(impalaStatistic.routes(), impalaStatistic.allowedMethods());
// error-handling
app.on('error', (err, ctx) => {
    console.error('server error', err, ctx);
});
setTimeout(() => {
    if (!time_interval_1.default.handleInterval) {
        time_interval_1.default.create();
    }
    // setTimeout(() => {
    //   TimeInterval.destroy()
    // }, 300000)
});
module.exports = app;
