"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sequelize_typescript_1 = require("sequelize-typescript");
const dot_task_model_1 = __importStar(require("../models/dot_task_model"));
const moment_1 = __importDefault(require("moment"));
const logUtil_1 = require("../utils/logUtil");
class DotTaskDao {
    /**
     * 创建Temp Res数据
     * @param data
     * @returns {Promise<*>}
     */
    static createDotTask(data) {
        return __awaiter(this, void 0, void 0, function* () {
            let rlt = undefined;
            // const transaction = await sequelize.Transaction;
            // const user = await User.findOne(..., { transaction });
            // await user.update(..., { transaction });
            data.forEach(item => {
                item.impalaExecStatus = dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.WAIT_FOR_EXEC;
            });
            // const trans = await ImpalaTaskModel.sequelize?.transaction()
            // if (trans) {
            try {
                rlt = yield dot_task_model_1.default.bulkCreate(data); // , { transaction: trans }
                // trans.commit()
                (0, logUtil_1.localLog)('我提交了，然后呢？');
            }
            catch (ex) {
                (0, logUtil_1.localLogErr)("error:", ex.message);
                // trans.rollback()
            }
            // }
            // const rlt = await entities.save()
            return rlt;
        });
    }
    static updatePendingDotTaskToFail() {
        return __awaiter(this, void 0, void 0, function* () {
            // const list = await DotTaskDao.getList(1, 20)
            // const trans = await ImpalaTaskModel.sequelize?.transaction()
            let rlt = [];
            // if (trans) {
            try {
                rlt = yield dot_task_model_1.default.update({
                    impalaExecStatus: dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.UNSUNCCESSFUL,
                    updateTime: Date.now()
                }, {
                    where: {
                        impalaExecStatus: dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.MS_EXEC_PENDING
                    },
                    // transaction: trans
                });
                // localLog("updatePendingDotTaskToFail 准备更新")
                // trans.commit()
                (0, logUtil_1.localLog)('-----------updatePendingDotTaskToFail 更新成功了');
            }
            catch (e) {
                (0, logUtil_1.localLogErr)('-----------updatePendingDotTaskToFail 更新失败了', e.message);
                // trans.rollback()
            }
            // }
            return rlt;
        });
    }
    static updateDotTask(data, status) {
        return __awaiter(this, void 0, void 0, function* () {
            let ids = [];
            data.forEach(item => {
                ids.push(item.id);
            });
            let rlt = [];
            // const trans = await ImpalaTaskModel.sequelize?.transaction()
            // if (trans) {
            try {
                rlt = yield dot_task_model_1.default.update({
                    impalaExecStatus: status,
                    updateTime: Date.now()
                }, {
                    where: {
                        id: {
                            [sequelize_typescript_1.Sequelize.Op.in]: ids,
                        }
                    },
                    // transaction: trans
                });
                (0, logUtil_1.localLog)("updateDotTask 准备更新");
                // trans.commit()
                (0, logUtil_1.localLog)('-----------updateDotTask 更新成功了');
            }
            catch (ex) {
                (0, logUtil_1.localLogErr)('-----------updateDotTask 更新失败了', ex.message);
                // trans.rollback()
            }
            // }
            (0, logUtil_1.localLog)(JSON.stringify(rlt));
            // const rlt = await entities.save()
            return rlt;
        });
    }
    static removeDotTask(ids) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let rlt = 0;
            let trans = yield ((_a = dot_task_model_1.default.sequelize) === null || _a === void 0 ? void 0 : _a.transaction());
            if (trans) {
                try {
                    for (let i = 0; i < ids.length; i++) {
                        rlt = yield dot_task_model_1.default.destroy({
                            where: {
                                id: ids[i],
                            },
                            transaction: trans
                        });
                    }
                    trans.commit();
                }
                catch (ex) {
                    console.log('error:', ex);
                    trans.rollback();
                }
            }
            return rlt;
        });
    }
    /**
     * 查询详情数据
     * @param id  id
     * @returns {Promise<Model>}
     */
    static getTaskDetail(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const rlt = yield dot_task_model_1.default.findOne({
                where: {
                    id,
                },
            });
            if (rlt) {
                rlt.actTimeRangeStart = Number(rlt.actTimeRangeStart || 0);
                rlt.actTimeRangeEnd = Number(rlt.actTimeRangeEnd || 0);
                rlt.createTime = Number(rlt.createTime || 0);
                rlt.updateTime = Number(rlt.updateTime || 0);
                rlt.events = JSON.parse(rlt.eventsStr || "[]");
            }
            return rlt;
        });
    }
    /**
     * 分页查询
     * @param pageIdx 页索引
     * @param pageSize 页大小
     * @returns {Promise<Model>}
     */
    static getList(pageIdx, pageSize, params) {
        return __awaiter(this, void 0, void 0, function* () {
            let offset = (pageIdx - 1) * pageSize;
            if (offset < 0)
                offset = 0;
            let stTimeStamp = new Date('1900-01-01').getTime();
            if (params && params.createTimeSt) {
                stTimeStamp = Number((0, moment_1.default)(new Date(params.createTimeSt)).startOf('day').format('x'));
            }
            let endTimeStamp = new Date('2999-12-30').getTime();
            if (params && params.createTimeEnd) {
                endTimeStamp = Number((0, moment_1.default)(new Date(params.createTimeEnd)).endOf('day').format('x'));
            }
            const where = {
                createTime: {
                    [sequelize_typescript_1.Sequelize.Op.gt]: stTimeStamp,
                    [sequelize_typescript_1.Sequelize.Op.lt]: endTimeStamp,
                },
                opdate: params && params.opdate ? params && params.opdate : undefined,
                appName: params && params.appname ? {
                    [sequelize_typescript_1.Sequelize.Op.like]: '%' + params.appname + '%'
                } : undefined,
                category: params && params.category ? {
                    [sequelize_typescript_1.Sequelize.Op.like]: '%' + params.category + '%'
                } : undefined,
                eventsStr: params && params.event ? {
                    [sequelize_typescript_1.Sequelize.Op.like]: '%' + params.event + '%'
                } : undefined,
                impalaExecStatus: params && params.impalaExecStatus ? params.impalaExecStatus : undefined
            };
            if (where.opdate === undefined)
                delete where.opdate;
            if (where.appName === undefined)
                delete where.appName;
            if (where.category === undefined)
                delete where.category;
            if (where.eventsStr === undefined)
                delete where.eventsStr;
            if (where.impalaExecStatus === undefined)
                delete where.impalaExecStatus;
            const rlt = yield dot_task_model_1.default.findAndCountAll({
                where,
                offset,
                limit: pageSize,
            });
            if (rlt && rlt.rows) {
                const newRlt = JSON.parse(JSON.stringify(rlt));
                newRlt.rows.forEach(item => {
                    item.actTimeRangeStart = Number(item.actTimeRangeStart || 0);
                    item.actTimeRangeEnd = Number(item.actTimeRangeEnd || 0);
                    item.createTime = Number(item.createTime || 0);
                    item.updateTime = Number(item.updateTime || 0);
                    item.events = JSON.parse(item.eventsStr || "[]");
                });
                return newRlt;
            }
            else {
                return rlt;
            }
        });
    }
}
exports.default = DotTaskDao;
