"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sequelize_1 = require("sequelize");
const dot_statistic_model_1 = __importDefault(require("../models/dot_statistic_model"));
const dot_task_model_1 = __importStar(require("../models/dot_task_model"));
const mysqlHelper_1 = __importDefault(require("../db/mysqlHelper"));
const logUtil_1 = require("../utils/logUtil");
const dot_statistic_rpt_model_1 = __importDefault(require("../models/dot_statistic_rpt_model"));
function truncateRptFields(data, maxLen) {
    if (!maxLen)
        maxLen = 200;
    data.forEach(it => {
        it.val1 = it.val1 && it.val1.length > maxLen ? it.val1.substring(0, maxLen - 3) + '...' : it.val1;
        it.val2 = it.val2 && it.val2.length > maxLen ? it.val2.substring(0, maxLen - 3) + '...' : it.val2;
        it.val3 = it.val3 && it.val3.length > maxLen ? it.val3.substring(0, maxLen - 3) + '...' : it.val3;
        it.val4 = it.val4 && it.val4.length > maxLen ? it.val4.substring(0, maxLen - 3) + '...' : it.val4;
        it.val5 = it.val5 && it.val5.length > maxLen ? it.val5.substring(0, maxLen - 3) + '...' : it.val5;
        it.val6 = it.val6 && it.val6.length > maxLen ? it.val6.substring(0, maxLen - 3) + '...' : it.val6;
        it.val7 = it.val7 && it.val7.length > maxLen ? it.val7.substring(0, maxLen - 3) + '...' : it.val7;
        it.val8 = it.val8 && it.val8.length > maxLen ? it.val8.substring(0, maxLen - 3) + '...' : it.val8;
        it.val9 = it.val9 && it.val9.length > maxLen ? it.val9.substring(0, maxLen - 3) + '...' : it.val9;
        it.val10 = it.val10 && it.val10.length > maxLen ? it.val10.substring(0, maxLen - 3) + '...' : it.val10;
    });
    return data;
}
class MixDao {
    /**
     * 插入统计数据 + 更新任务状态为: 执行成功/执行失败 (data为null，直接更新为失败状态)
     * @param data
     * @param tasks
     * @returns
     */
    static invokeStatisticInsertAndTaskStatusUpdate(data, tasks) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let rlt2 = undefined;
            // const transaction = await sequelize.Transaction;
            // const user = await User.findOne(..., { transaction });
            // await user.update(..., { transaction });
            let taskIds = [];
            tasks.forEach(item => {
                taskIds.push(item.id);
            });
            let isBigTransError = false;
            if (data) {
                const trans = yield mysqlHelper_1.default.transaction();
                if (trans) {
                    try {
                        (0, logUtil_1.localLog)('----------');
                        if (data.length > 0) {
                            let rlt1 = [];
                            console.log('impalaRltDataSetType => ', Number(tasks[0].impalaRltDataSetType));
                            if (Number(tasks[0].impalaRltDataSetType) === dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_RPT_STATISTICS_TABLE) {
                                // 报表统计数据
                                let rptStatisticItems = truncateRptFields(data, 200);
                                rlt1 = yield dot_statistic_rpt_model_1.default.bulkCreate(rptStatisticItems, { transaction: trans });
                            }
                            else if (Number(tasks[0].impalaRltDataSetType) === dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_STATISTICS_TABLE) {
                                // 埋点统计数据
                                let dotStatisticItems = data;
                                rlt1 = yield dot_statistic_model_1.default.bulkCreate(dotStatisticItems, { transaction: trans });
                            }
                            if (rlt1.length > 0) {
                                (0, logUtil_1.localLog)('----------invokeStatisticInsertAndTaskStatusUpdate 数据插入Pre成功: ' + rlt1.length);
                            }
                            else {
                                (0, logUtil_1.localLog)('----------invokeStatisticInsertAndTaskStatusUpdate 数据插入Pre成功: 0');
                            }
                        }
                        else {
                            (0, logUtil_1.localLog)('----------invokeStatisticInsertAndTaskStatusUpdate 无数据插入Pre');
                        }
                        rlt2 = yield dot_task_model_1.default.update({
                            impalaExecStatus: dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.SUCCESSFUL,
                            updateTime: Date.now()
                        }, {
                            where: {
                                id: {
                                    [sequelize_1.Sequelize.Op.in]: taskIds,
                                }
                            },
                            transaction: trans
                        });
                        (0, logUtil_1.localLog)('----------invokeStatisticInsertAndTaskStatusUpdate 状态更新Pre成功: ' + rlt2[0]);
                        trans.commit();
                        (0, logUtil_1.localLog)('-----------invokeStatisticInsertAndTaskStatusUpdate 执行成功了');
                    }
                    catch (ex) {
                        (0, logUtil_1.localLogErr)('-----------invokeStatisticInsertAndTaskStatusUpdate 执行失败了', JSON.stringify(ex));
                        trans.rollback();
                        isBigTransError = true;
                        // const trans2 = await DotStatisticModel.sequelize?.transaction()
                        // if (trans2) {
                        //     const rltUpdateFailed = await MixDao.updateTaskFailedByTaskIds(taskIds, trans2)
                        //     if (rltUpdateFailed){
                        //         trans2.commit()
                        //         localLog('-----------状态UNSUNCCESSFUL 更新成功了')
                        //     }
                        //     else {
                        //         trans2.rollback()
                        //     }
                        // }
                    }
                }
            }
            else {
                // 获取数据错误
                console.log('-----------invokeStatisticInsertAndTaskStatusUpdate 执行失败了 no_data');
                isBigTransError = true;
            }
            if (isBigTransError) {
                const trans2 = yield ((_a = dot_statistic_model_1.default.sequelize) === null || _a === void 0 ? void 0 : _a.transaction());
                if (trans2) {
                    const rltUpdateFailed = yield MixDao.updateTaskFailedByTaskIds(taskIds, trans2);
                    if (rltUpdateFailed) {
                        trans2.commit();
                        (0, logUtil_1.localLog)('-----------invokeStatisticInsertAndTaskStatusUpdate 状态UNSUNCCESSFUL 更新成功了');
                    }
                    else {
                        trans2.rollback();
                    }
                }
            }
            return rlt2 || [];
        });
    }
    static updateTaskFailedByTaskIds(taskIds, trans2) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const rlt2 = yield dot_task_model_1.default.update({
                    impalaExecStatus: dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.UNSUNCCESSFUL,
                    updateTime: Date.now()
                }, {
                    where: {
                        id: {
                            [sequelize_1.Sequelize.Op.in]: taskIds,
                        }
                    },
                    transaction: trans2
                });
                (0, logUtil_1.localLog)("准备去更新:" + rlt2.length);
                return true;
            }
            catch (e) {
                (0, logUtil_1.localLogErr)('-----------状态UNSUNCCESSFUL 更新失败了', e.message);
                return false;
            }
        });
    }
}
exports.default = MixDao;
