"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// import sequelize from "sequelize"
// import DotStatisticDao from "../campaign/dot_statistic_campaign"
const dot_task_campaign_1 = __importDefault(require("../campaign/dot_task_campaign"));
const impalaHelper_1 = require("../db/impalaHelper");
const dot_task_model_1 = require("../models/dot_task_model");
const utils_1 = require("../utils");
const mix_campaign_1 = __importDefault(require("../campaign/mix_campaign"));
const logUtil_1 = require("../utils/logUtil");
const base_1 = require("../db/base");
class TimeInterval {
    constructor() {
    }
    /**按时执行的方法体 */
    static intervalBellExec() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield dot_task_campaign_1.default.updatePendingDotTaskToFail();
                (0, logUtil_1.localLog)('1/4. OldItems 状态MS_EXEC_PENDING->UNSUNCCESSFUL更新 成功');
            }
            catch (e) {
                (0, logUtil_1.localLog)('1/4. OldItems 状态MS_EXEC_PENDING->UNSUNCCESSFUL更新 失败', e.message);
                (0, logUtil_1.localLogErr)('DotTaskDao.updatePendingDotTaskToFail err');
            }
            // 从数据库读取一条 tasks，然后调用执行并插入
            const listData = yield dot_task_campaign_1.default.getList(1, 1, {
                impalaExecStatus: dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.WAIT_FOR_EXEC
            });
            (0, logUtil_1.localLog)('定时任务：寻找待执行任务进行执行！', String(listData && listData.rows ? listData.rows.length : 0));
            if (listData && listData.rows.length > 0) {
                try {
                    // p1: 改变状态 ENUM_IMPALA_QUERY_EXEC_STATUS.MS_EXEC_PENDING
                    const res1 = yield dot_task_campaign_1.default.updateDotTask(listData.rows, dot_task_model_1.ENUM_IMPALA_QUERY_EXEC_STATUS.MS_EXEC_PENDING);
                    if (res1.length > 0) {
                        (0, logUtil_1.localLog)('2/4. 状态MS_EXEC_PENDING更新 成功: ' + res1.length);
                    }
                    else {
                        (0, logUtil_1.localLog)('2/4. 状态MS_EXEC_PENDING更新 成功: 0');
                    }
                }
                catch (e) {
                    (0, logUtil_1.localLog)('2/4. 状态MS_EXEC_PENDING更新 失败', e.message);
                    (0, logUtil_1.localLogErr)('DotTaskDao.updateDotTask err', JSON.stringify(listData.rows));
                }
                // 如果是多条数据，需要拆成单条数据进行发送
                // let dotTasks: IImpalaTaskModel[] = listData.rows.filter(it => it.impalaRltDataSetType===ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_STATISTICS_TABLE)
                // let rptTasks: IImpalaTaskModel[] = listData.rows.filter(it => it.impalaRltDataSetType===ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_RPT_STATISTICS_TABLE)
                let impalaRltRes = [];
                try {
                    // p2: 执行查询
                    (0, logUtil_1.localLog)('listData.rows1=>', JSON.stringify(listData.rows));
                    const impalaRltDataSetType = Number(listData.rows[0].impalaRltDataSetType);
                    if (impalaRltDataSetType === dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_STATISTICS_TABLE) {
                        impalaRltRes = yield TimeInterval.batchExecImpalaDotStatistic(listData.rows);
                    }
                    else if (impalaRltDataSetType === dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_RPT_STATISTICS_TABLE) {
                        impalaRltRes = yield TimeInterval.batchExecImpalaRptStatistic(listData.rows);
                    }
                    else {
                        (0, logUtil_1.localLog)('No matched impalaRltDataSetType.');
                    }
                    if (impalaRltRes) {
                        (0, logUtil_1.localLog)('3/4. impala查询数据执行成功: ' + impalaRltRes.length);
                    }
                    else {
                        (0, logUtil_1.localLog)('3/4. impala查询数据执行失败');
                    }
                }
                catch (e) {
                    (0, logUtil_1.localLog)('3/4. impala查询数据执行 失败', e.message);
                    (0, logUtil_1.localLogErr)('batchExecImpalaDotStatistic err', JSON.stringify(listData.rows));
                }
                try {
                    // p3: 插入数据与更新状态
                    console.log("listData.rows2=>", listData.rows);
                    const res3 = yield mix_campaign_1.default.invokeStatisticInsertAndTaskStatusUpdate(impalaRltRes, listData.rows);
                    if (res3.length > 0) {
                        (0, logUtil_1.localLog)('4/4. 插入数据与更新状态: ' + res3.length);
                    }
                    else {
                        (0, logUtil_1.localLog)('4/4. 插入数据与更新状态: 0');
                    }
                }
                catch (e) {
                    // p4: 修改标记
                    (0, logUtil_1.localLog)('4/4. 插入数据与更新状态: 失败', e.message);
                    (0, logUtil_1.localLogErr)('invokeStatisticInsertAndTaskStatusUpdate err', JSON.stringify(listData.rows));
                }
            }
        });
    }
    static create() {
        // if (process.env.NODE_ENV === 'development') {
        //     // 开发状态下不进行自动执行
        //     return
        // }
        // 定时获取任务，并删除 (当前pm2进程数控制为1)
        TimeInterval.handleInterval = setInterval(TimeInterval.intervalBellExec, 15 * 60 * 1000);
        TimeInterval.intervalBellExec();
    }
    static destroy() {
        clearInterval(TimeInterval.handleInterval);
        TimeInterval.handleInterval = undefined;
    }
    /**批量执行统计任务 */
    static batchExecImpalaDotStatistic(tasks) {
        return __awaiter(this, void 0, void 0, function* () {
            const columns = [];
            columns.push({ name: 'event', type: 'string' });
            columns.push({ name: 'userdotcnt', type: 'number' });
            columns.push({ name: 'dotcnt', type: 'number' });
            const dataRlt = [];
            for (let i = 0; i < tasks.length; i++) {
                const task = tasks[i];
                if (Number(task.impalaRltDataSetType) === Number(dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_STATISTICS_TABLE) ||
                    Number(task.impalaRltDataSetType) === Number(dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_RPT_STATISTICS_TABLE)) {
                    // 改变状态 ENUM_IMPALA_QUERY_EXEC_STATUS.WAIT_FOR_EXEC
                    let impalaResItemsRlt;
                    (0, logUtil_1.localLog)('去执行impala查询=>', JSON.stringify(task.impalaQuerySql));
                    try {
                        impalaResItemsRlt = yield (0, impalaHelper_1.execImpalaSql)(task.impalaQuerySql, columns);
                    }
                    catch (e) {
                        (0, logUtil_1.localLogErr)('去执行impala查询执行失败2=>', e.message);
                        (0, logUtil_1.localLogErr)('execImpalaSql err', task.impalaQuerySql);
                        return null;
                    }
                    let nowTimeStamp = Date.now();
                    if (impalaResItemsRlt.Result === 1 && impalaResItemsRlt.data) {
                        (0, logUtil_1.localLog)('去执行impala查询执行完毕=>', JSON.stringify(impalaResItemsRlt.data));
                        for (let j = 0; j < impalaResItemsRlt.data.length; j++) {
                            const impalaResItem = impalaResItemsRlt.data[j];
                            const rltItem = {
                                id: (0, utils_1.getGuid)(),
                                opdate: task.opdate,
                                event: '',
                                category: task.category,
                                appName: task.appName,
                                val1: 0,
                                val2: 0,
                                val3: 0,
                                createTime: nowTimeStamp,
                                updateTime: nowTimeStamp
                            };
                            for (let k = 0; k < columns.length; k++) {
                                let key = columns[k].name;
                                let val = impalaResItem.get(key);
                                if (key === 'event') {
                                    rltItem.event = val || '';
                                }
                                else if (key === 'userdotcnt') {
                                    rltItem.val1 = Number(val || 0);
                                }
                                else if (key === 'dotcnt') {
                                    rltItem.val2 = Number(val || 0);
                                }
                            }
                            dataRlt.push(rltItem);
                        }
                    }
                    else {
                        (0, logUtil_1.localLogErr)('去执行impala查询执行失败1=>', task.impalaQuerySql);
                        return null;
                    }
                }
                else {
                    console.error('Not implements!');
                }
            }
            return dataRlt;
        });
    }
    /**批量执行统计任务 */
    static batchExecImpalaRptStatistic(tasks) {
        return __awaiter(this, void 0, void 0, function* () {
            const dataRlt = [];
            for (let i = 0; i < tasks.length; i++) {
                const task = tasks[i];
                if (Number(task.impalaRltDataSetType) === Number(dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_STATISTICS_TABLE) ||
                    Number(task.impalaRltDataSetType) === Number(dot_task_model_1.ENUM_IMPALA_RLT_DATASET_TYPE.TO_MYSQL_RPT_STATISTICS_TABLE)) {
                    // 改变状态 ENUM_IMPALA_QUERY_EXEC_STATUS.WAIT_FOR_EXEC
                    let impalaResItemsRlt;
                    task.impalaQuerySql = task.impalaQuerySql.replace(/\$\{dateStr\}/, task.opdate);
                    // 获取列
                    const columns = [];
                    const _cols2 = (0, base_1.getColNamesFromImpalaSql)(task.impalaQuerySql);
                    _cols2.forEach(_col2 => {
                        columns.push({
                            name: _col2,
                            type: 'string'
                        });
                    });
                    (0, logUtil_1.localLog)('去执行impala查询=>', JSON.stringify(task.impalaQuerySql), '=>', JSON.stringify(columns));
                    try {
                        impalaResItemsRlt = yield (0, impalaHelper_1.execImpalaSql)(task.impalaQuerySql, columns);
                    }
                    catch (e) {
                        (0, logUtil_1.localLogErr)('去执行impala查询执行失败=>', e.message);
                        (0, logUtil_1.localLogErr)('execImpalaSql err', task.impalaQuerySql);
                        return null;
                    }
                    let nowTimeStamp = Date.now();
                    if (impalaResItemsRlt.Result === 1 && impalaResItemsRlt.data) {
                        // console.log(impalaResItemsRlt.data)
                        (0, logUtil_1.localLog)('去执行impala查询执行完毕=>', JSON.stringify(impalaResItemsRlt.data));
                        for (let j = 0; j < impalaResItemsRlt.data.length; j++) {
                            const impalaResItem = impalaResItemsRlt.data[j];
                            const rltItem = {
                                id: (0, utils_1.getGuid)(),
                                opdate: task.opdate,
                                prdlineCode: task.prdlineCode,
                                rptModId: task.rptModId,
                                createTime: nowTimeStamp,
                                updateTime: nowTimeStamp
                            };
                            for (let _item of impalaResItem) {
                                const _val = _item[1] || "NULL";
                                // console.log('ttttttttt', _item, impalaResItem);
                                if (!rltItem.val1)
                                    rltItem.val1 = _val;
                                else if (!rltItem.val2)
                                    rltItem.val2 = _val;
                                else if (!rltItem.val3)
                                    rltItem.val3 = _val;
                                else if (!rltItem.val4)
                                    rltItem.val4 = _val;
                                else if (!rltItem.val5)
                                    rltItem.val5 = _val;
                                else if (!rltItem.val6)
                                    rltItem.val6 = _val;
                                else if (!rltItem.val7)
                                    rltItem.val7 = _val;
                                else if (!rltItem.val8)
                                    rltItem.val8 = _val;
                                else if (!rltItem.val9)
                                    rltItem.val9 = _val;
                                else if (!rltItem.val10)
                                    rltItem.val10 = _val;
                            }
                            dataRlt.push(rltItem);
                        }
                    }
                    else {
                        (0, logUtil_1.localLogErr)('去执行impala查询执行失败1=>', task.impalaQuerySql);
                        return null;
                    }
                }
                else {
                    console.error('Not implements!');
                }
            }
            return dataRlt;
        });
    }
    static ImpalaTask(...args) {
    }
}
exports.default = TimeInterval;
