"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ENUM_IMPALA_QUERY_EXEC_STATUS = exports.ENUM_IMPALA_RLT_DATASET_TYPE = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const mysqlHelper_1 = __importDefault(require("../db/mysqlHelper"));
/**结果集类型 */
var ENUM_IMPALA_RLT_DATASET_TYPE;
(function (ENUM_IMPALA_RLT_DATASET_TYPE) {
    /**个人镜像数据 */
    ENUM_IMPALA_RLT_DATASET_TYPE[ENUM_IMPALA_RLT_DATASET_TYPE["TO_MYSQL_PERSONAL_TABLE"] = 1] = "TO_MYSQL_PERSONAL_TABLE";
    /**Category埋点集合下的统计数据 */
    ENUM_IMPALA_RLT_DATASET_TYPE[ENUM_IMPALA_RLT_DATASET_TYPE["TO_MYSQL_STATISTICS_TABLE"] = 2] = "TO_MYSQL_STATISTICS_TABLE";
    /**产品线与报表子模块下的统计数据 */
    ENUM_IMPALA_RLT_DATASET_TYPE[ENUM_IMPALA_RLT_DATASET_TYPE["TO_MYSQL_RPT_STATISTICS_TABLE"] = 3] = "TO_MYSQL_RPT_STATISTICS_TABLE";
})(ENUM_IMPALA_RLT_DATASET_TYPE = exports.ENUM_IMPALA_RLT_DATASET_TYPE || (exports.ENUM_IMPALA_RLT_DATASET_TYPE = {}));
/**查询任务的执行状态 */
var ENUM_IMPALA_QUERY_EXEC_STATUS;
(function (ENUM_IMPALA_QUERY_EXEC_STATUS) {
    /**1.待执行：应用服务已将任务送入微服务，但微服务尚未进入进行时 */
    ENUM_IMPALA_QUERY_EXEC_STATUS[ENUM_IMPALA_QUERY_EXEC_STATUS["WAIT_FOR_EXEC"] = 1] = "WAIT_FOR_EXEC";
    /**2.微服务排对执行中：微服务已经读入执行队列，很快将进入impala执行，尚未完成查询 */
    ENUM_IMPALA_QUERY_EXEC_STATUS[ENUM_IMPALA_QUERY_EXEC_STATUS["MS_EXEC_PENDING"] = 2] = "MS_EXEC_PENDING";
    /**3.Impala执行中：微服务已经发送impala，尚未完成查询 */
    ENUM_IMPALA_QUERY_EXEC_STATUS[ENUM_IMPALA_QUERY_EXEC_STATUS["IMPALA_EXEC_PENDING"] = 3] = "IMPALA_EXEC_PENDING";
    /**4.impala/mysql执行完成 */
    ENUM_IMPALA_QUERY_EXEC_STATUS[ENUM_IMPALA_QUERY_EXEC_STATUS["SUCCESSFUL"] = 4] = "SUCCESSFUL";
    /**5.impala/mysql执行报错 */
    ENUM_IMPALA_QUERY_EXEC_STATUS[ENUM_IMPALA_QUERY_EXEC_STATUS["UNSUNCCESSFUL"] = 5] = "UNSUNCCESSFUL";
})(ENUM_IMPALA_QUERY_EXEC_STATUS = exports.ENUM_IMPALA_QUERY_EXEC_STATUS || (exports.ENUM_IMPALA_QUERY_EXEC_STATUS = {}));
let ImpalaTaskModel = class ImpalaTaskModel extends sequelize_typescript_1.Model {
};
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        primaryKey: true,
        allowNull: false,
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "id", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "batch_id",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "batchId", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "category",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "category", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "appname",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "appName", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "events_str",
        validate: {
            len: [0, 5000],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "eventsStr", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "prdline_code",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "prdlineCode", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "rpt_mod_id",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "rptModId", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "opdate",
        validate: {
            len: [0, 200],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "opdate", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: false,
        field: "acttime_range_start",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "actTimeRangeStart", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: true,
        field: "acttime_range_end",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "actTimeRangeEnd", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: false,
        field: "impala_querysql",
        validate: {
            len: [0, 5000],
        },
    }),
    __metadata("design:type", String)
], ImpalaTaskModel.prototype, "impalaQuerySql", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: false,
        field: "impalarlt_dataset_type",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "impalaRltDataSetType", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: false,
        field: "impala_exec_status",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "impalaExecStatus", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: false,
        field: "create_time",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "createTime", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.NUMBER,
        allowNull: false,
        field: "update_time",
    }),
    __metadata("design:type", Number)
], ImpalaTaskModel.prototype, "updateTime", void 0);
ImpalaTaskModel = __decorate([
    (0, sequelize_typescript_1.Table)({
        tableName: "dot_task_impala",
        timestamps: false,
        freezeTableName: true,
    })
], ImpalaTaskModel);
mysqlHelper_1.default.addModels([ImpalaTaskModel]);
exports.default = ImpalaTaskModel;
