"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dot_statistic_campaign_1 = __importDefault(require("../campaign/dot_statistic_campaign"));
const rpt_statistic_campaign_1 = __importDefault(require("../campaign/rpt_statistic_campaign"));
const impalaStatisticRouter = require('koa-router')();
// // 添加数据
// impalaStatisticRouter.post('/pushStatistic', async (ctx: {
//     request: {
//         body: IDataQueryTaskItem[]
//     },
//     body: ICommonEntityRlt<IDotStatisticModel[]>
// }, next: any) => {
// })
/**查询埋点统计数据接口 */
impalaStatisticRouter.post('/getDotStatistic', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    const postData = ctx.request.body;
    try {
        const res = yield dot_statistic_campaign_1.default.getList(postData.pageIdx, postData.pageSize, {
            appName: postData.appName,
            category: postData.category,
            opdate: postData.opdate,
            createTimeSt: postData.createTimeSt,
            createTimeEnd: postData.createTimeEnd,
            event: postData.event,
        });
        ctx.body = {
            Result: 1,
            code: 200,
            pageIndex: postData.pageIdx,
            pageSize: postData.pageSize,
            data: res.rows,
            totalCount: res.count
        };
    }
    catch (e) {
        ctx.body = {
            Result: 0,
            code: 0,
            pageIndex: postData.pageIdx,
            pageSize: postData.pageSize,
            totalCount: 0,
            message: 'error:' + e.message
        };
    }
}));
/**批量查询(无分页) */
impalaStatisticRouter.post('/getDotStatisticByEvts', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    const postData = ctx.request.body;
    if (!postData.opdate || !postData.events || postData.events.length === 0) {
        ctx.body = {
            Result: 0,
            code: 500,
            message: 'error: opdate and events are not allowed in empty value.'
        };
    }
    try {
        const rows = yield dot_statistic_campaign_1.default.getAllList({
            appNames: postData.appNames,
            categories: postData.categories,
            opdate: postData.opdate,
            events: postData.events,
        });
        if (rows) {
            ctx.body = {
                Result: 1,
                code: 200,
                data: rows,
            };
        }
        else {
            ctx.body = {
                Result: 0,
                code: 200,
                message: "Unknown Error.",
            };
        }
    }
    catch (e) {
        ctx.body = {
            Result: 0,
            code: 500,
            message: 'error:' + e.message
        };
    }
}));
/**查询报表统计数据接口 */
impalaStatisticRouter.post('/getRptStatistic', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    const postData = ctx.request.body;
    try {
        const res = yield rpt_statistic_campaign_1.default.getList(postData.pageIdx, postData.pageSize, {
            prdlineCode: postData.prdlineCode,
            rptModIds: postData.rptModIds,
            opdate: postData.opdate,
            createTimeSt: postData.createTimeSt,
            createTimeEnd: postData.createTimeEnd,
        });
        ctx.body = {
            Result: 1,
            code: 200,
            pageIndex: postData.pageIdx,
            pageSize: postData.pageSize,
            data: res.rows,
            totalCount: res.count
        };
    }
    catch (e) {
        ctx.body = {
            Result: 0,
            code: 0,
            pageIndex: postData.pageIdx,
            pageSize: postData.pageSize,
            totalCount: 0,
            message: 'error:' + e.message
        };
    }
}));
// 修改
// 删除
// impalaStatisticRouter.post('/delDotStatistic', async (ctx: {
//     request: {
//         body: IDataQueryTaskItem[]
//     },
//     body: ICommonEntityRlt<IDotStatisticModel[]>
// }, next: any) => {
// })
impalaStatisticRouter.post('/testImpalaQuery', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    // const res = await DotStatisticDao.createDotStatistic([{{}]
}));
// 自测试通过
impalaStatisticRouter.post('/testSaveMySqlDotStatistic', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    const res = yield dot_statistic_campaign_1.default.createDotStatistic([{
            id: "id1",
            opdate: "2022-09-15",
            event: "dotEvtName1",
            category: 'category1',
            appName: 'appname1',
            val1: 13,
            val2: 12,
            val3: 11,
            createTime: 1663053873526,
            updateTime: 1663053873526
        }, {
            id: "id2",
            opdate: "2022-09-15",
            event: "dotEvtName2",
            category: 'category2',
            appName: 'appname2',
            val1: 3,
            val2: 2,
            val3: 1,
            createTime: 1663053873526,
            updateTime: 1663053873526
        }]);
    if (res && res.length > 0) {
        ctx.body = {
            Result: 1,
            code: 200,
            // data: true,
            message: ''
        };
    }
    else {
        ctx.body = {
            Result: 0,
            code: 0,
            data: false,
            message: ''
        };
    }
}));
// 自测试通过
impalaStatisticRouter.post('/testRemoveMySqlDotStatistic', (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    const dd = yield dot_statistic_campaign_1.default.removeDotStatistic(["id1", "id2"]);
    ctx.body = {
        title: 'testRemoveMySql'
    };
}));
module.exports = impalaStatisticRouter;
